#!/usr/bin/env ruby1.9
require 'PottyMouth'

contents = [
  ["""
Here is a _paragraph_ with big _fat_ long text lines
that go *on and_ on* forever with no end in sight.

Yes, that's right,  another paragraph. http://google.com/ is my site
Will wonders ever cease?
""",
   [Node.new(:P, [
	       Node.new(:span, ['Here is a ']),
	       Node.new(:i, [Node.new(:span, ['paragraph'])]),
	       Node.new(:span, [' with big ']),
	       Node.new(:i, [
			  Node.new(:span, ['fat']),
			]),
	       Node.new(:span, [" long text lines \nthat go "]),
	       Node.new(:b, [
			  Node.new(:span, ["on and\n_\n on"]),
			]),
	       Node.new(:span, [' forever with no end in sight. '])
	       ]),
      Node.new(:P, [
		 Node.new(:span, ['Yes, that&#8217;s right,  another paragraph. ']),
		 LinkNode.new('http://google.com/'),
		 Node.new(:span, [" is my site \nWill wonders ever cease? "]),
	       ]),
    ]
  ],
  ["""
this paragraph
has short
lines so it
should get
break tags
all over the
place
""",
    [Node.new(:P, [
		Node.new(:span, ['this paragraph ']),
		Node.new(:br),
		Node.new(:span, ['has short ']),
		Node.new(:br),
		Node.new(:span, ['lines so it ']),
		Node.new(:br),
		Node.new(:span, ['should get ']),
		Node.new(:br),
		Node.new(:span, ['break tags ']),
		Node.new(:br),
		Node.new(:span, ['all over the ']),
		Node.new(:br),
		Node.new(:span, ['place ']),
	      ])
    ]
  ],

  ["""This paragraph has a list embedded in the middle of itself:
item one
item two
item three
See, wasn't that easy?""",
   [Node.new(:P, [
       Node.new(:span, ['This paragraph has a list embedded in the middle of itself: ']),
       Node.new(:br),
       Node.new(:span, ['item one ']),
       Node.new(:br),
       Node.new(:span, ['item two ']),
       Node.new(:br),
       Node.new(:span, ['item three ']),
       Node.new(:br),
       Node.new(:span, ['See, wasn&#8217;t that easy?']),
       ]),
    ]
   ],

  ["""
item one
item two
item three
See, wasn't that easy?""",
   [Node.new(:p, [
       Node.new(:span, ['item one ']),
       Node.new(:br),
       Node.new(:span, ['item two ']),
       Node.new(:br),
       Node.new(:span, ['item three ']),
       Node.new(:br),
       Node.new(:span, ['See, wasn&#8217;t that easy?'])
	     ]),
    ]
   ],
  
  ["""This paragraph has a list embedded in the middle of itself:
item one
item two
item thre
""",
   [Node.new(:p, [
       Node.new(:span, ['This paragraph has a list embedded in the middle of itself: ']),
       Node.new(:br),
       Node.new(:span, ['item one ']),
       Node.new(:br),
       Node.new(:span, ['item two ']),
       Node.new(:br),
       Node.new(:span, ['item thre ']),
	     ]),
    ]
   ],

  ["""
This paragraph is classic and typical evidence of why the process of hard text
wrapping
was ultimately a short-sighted practice that was deeply, wholly and firmly
grounded
in complete idiocy, sincerely stupid and fallacious techniques and practices
of programming.
""",
    [Node.new(:p, [
		Node.new(:span, [
			   "This paragraph is classic and typical evidence of why the process of hard text \n" + 
			   "wrapping \n" + 
			   "was ultimately a short-sighted practice that was deeply, wholly and firmly \n" + 
			   "grounded \n" + 
			   "in complete idiocy, sincerely stupid and fallacious techniques and practices \n" + 
			   "of programming. "
			 ])
	      ])
    ],
  ],
  ["""
This is a reply to an reply
> this is a reply
> > this is the original
> > and another original line
> > aand yet ononther ariginal
> >
> > more of the original in a different block quote
> more of the reply
>
> even more reply
> wow this just keeps going
rest of the message

no news 
""",
    [Node.new(:p, [
		Node.new(:span, ['This is a reply to an reply ']),
		Node.new(:blockquote, [
			   Node.new(:p, [
				      Node.new(:span, ['this is a reply ']),
				      Node.new(:blockquote, [
						 Node.new(:p, [
							    Node.new(:span, ['this is the original ']),
							    Node.new(:br),
							    Node.new(:span, ['and another original line ']),
							    Node.new(:br),
							    Node.new(:span, ['aand yet ononther ariginal ']),
							  ])
					       ]),
				      Node.new(:blockquote, [
						 Node.new(:p, [
							    Node.new(:span, ['more of the original in a different block quote ']),
							  ]),
					       ]),
				      Node.new(:span, ['more of the reply ']),
				    ])
			 ]),
		Node.new(:blockquote, [
			   Node.new(:p, [
				      Node.new(:span, ['even more reply ']),
				      Node.new(:br),
				      Node.new(:span, ['wow this just keeps going '])
				    ]),
			 ]),
		Node.new(:span, ['rest of the message ']),
	      ]),
      Node.new(:p, [
		 Node.new(:span, ['no news  '])
	       ])
    ]
   ],

  ["""You suck
> no, you suck
>> no, really, you suck
>>> I told you, you are the sucky one
> whatever you say

eat shit with your findegs
this iss also shit

eat shit some more """,
    [Node.new(:p, [
		Node.new(:span, ['You suck ']),
		Node.new(:blockquote, [
			   Node.new(:p, [
				      Node.new(:span, ['no, you suck ']),
				      Node.new(:blockquote, [
						 Node.new(:p, [
							    Node.new(:span, ['no, really, you suck ']),
							    Node.new(:blockquote, [
								       Node.new(:p, [
										  Node.new(:span, ['I told you, you are the sucky one '])
										]),
								     ]),
							  ]),
						 ]),
				      Node.new(:span, ['whatever you say ']),
				    ])
			 ]),
	      ]),
      Node.new(:p, [
		 Node.new(:span, ['eat shit with your findegs ']),
		 Node.new(:br),
		 Node.new(:span, ['this iss also shit ']),
	       ]),
      Node.new(:p, [
		 Node.new(:span, ['eat shit some more '])
		 ]),
    ]
   ],

  [""">>> this begins a deep quote
>>> this ends a deep quote
""",
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:p, [
				      Node.new(:blockquote, [
						 Node.new(:p, [
							    Node.new(:blockquote, [
								       Node.new(:p, [
										  Node.new(:span, ['this begins a deep quote ']),
										  Node.new(:br),
										  Node.new(:span, ['this ends a deep quote ']),
										  ]),
								       ]),
							  ]),
					       ]),
				    ]),
			 ]),
	      ]),
    ]
   ],
  [""">>>> a very very deep quote
>> not so deep of a quote
>>> middle of the road
> deatherly quotingly
""",
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:p, [
				      Node.new(:blockquote, [
						 Node.new(:p, [
							    Node.new(:blockquote, [
								       Node.new(:p, [
										  Node.new(:blockquote, [
											     Node.new(:p, [
													Node.new(:span, ['a very very deep quote ']),
													]),
											     ]),
										  ]),
								     ]),
							    Node.new(:span, ['not so deep of a quote ']),
							    Node.new(:blockquote, [
								       Node.new(:p, [
										  Node.new(:span, ['middle of the road '])
										  ])
								     ]),
							  ]),
					       ]),
				      Node.new(:span, ['deatherly quotingly ']),
				    ]),
			 ]),
	      ]),
    ]
   ],

  ["""> early in the quote
>>>> deep in the quote
not quoted at all
""",
   [Node.new(:p, [
	       Node.new(:blockquote, [
			  Node.new(:p, [
				     Node.new(:span, ['early in the quote ']),
				     Node.new(:blockquote, [
						Node.new(:p, [
							   Node.new(:blockquote, [
								      Node.new(:p, [
										 Node.new(:blockquote, [
											    Node.new(:p, [
												       Node.new(:span, ['deep in the quote ']),
												     ]),
											  ]),
									       ]),
								    ]),
							 ]),
					      ]),
				   ]),
			]),
	       Node.new(:span, ['not quoted at all ']),
	     ])
    ]
  ],

  ["""This should be a URL http://mysite.com/allowed/service but this should not be http://mysite.COM/something/dangerous. And finally, these two should also be allowed http://mysite.com/safe/url and http://another.site.com/something/else.""",
    [Node.new(:p, [
		Node.new(:span, ['This should be a URL ']),
		LinkNode.new('http://mysite.com/allowed/service', internal=true),
		Node.new(:span, [" but this should not be \nhttp://mysite.COM/something/dangerous\n. And finally, these two should also be allowed "]),
		LinkNode.new('http://mysite.com/safe/url', internal=true),
		Node.new(:span, [' and ']),
		LinkNode.new('http://another.site.com/something/else'),
		Node.new(:span, ['.']),
	      ])
    ]
  ],
  ["française",
   [Node.new(:p, [
       Node.new(:span, ['fran&#231;aise'])
       ]),
    ]
  ],
  ["""short line
short line
short line
a very very long line that surpasses the maximum short line length""",
    [Node.new(:p, [
       Node.new(:span, ['short line ']),
       Node.new(:br),
       Node.new(:span, ['short line ']),
       Node.new(:br),
       Node.new(:span, ['short line ']),
       Node.new(:br),
       Node.new(:span, ['a very very long line that surpasses the maximum short line length']),
	      ])
    ]
  ],
  ["""two short lines
all by themselves
""",
   [Node.new(:p, [
       Node.new(:span, ['two short lines ']),
       Node.new(:br),
       Node.new(:span, ['all by themselves ']),
	     ])
    ]
  ],
  ["""***just a bold***""",
   [Node.new(:p, [
       Node.new(:b, [
		  Node.new(:span, ['just a bold']),
		]),
	     ]),
    ]
  ],
  ["""**the Higgs Boson is not bold**""",
   [Node.new(:p, [
       Node.new(:span, ['the Higgs Boson is not bold']),
	     ]),
    ]
  ],
  ["A paragraph separated from the next one with a line\n" +
   "  \n" +
   "that contains just some whitespace becomes two paragraphs\n", 
    [Node.new(:p, [
		Node.new(:span, ['A paragraph separated from the next one with a line '])
	      ]),
      Node.new(:p, [
		 Node.new(:span, ['that contains just some whitespace becomes two paragraphs '])
	       ]),
    ]
  ],
  ["A paragraph separated from the next one with a line\n" +
   "\t\n" +
   "that contains just a tab becomes two paragraphs\n",
   [Node.new(:p, [
       Node.new(:span, ['A paragraph separated from the next one with a line '])
	     ]),
    Node.new(:p, [
       Node.new(:span, ['that contains just a tab becomes two paragraphs '])
	     ]),
    ]
   ],
  ["this is someone's e.mail@email.com address",
   [Node.new(:p, [
	       Node.new(:span, ["this is someone&#8217;s "]),
	       EmailNode.new('e.mail@email.com'),
	       Node.new(:span, [' address']),
	     ]),
    ],
  ],
  ["And shit, this http://www.theory.org/~matt/matt-1.jpg is an image.",
   [Node.new(:p, [
       Node.new(:span, ["And shit, this "]),
       ImageNode.new('http://www.theory.org/~matt/matt-1.jpg'),
       Node.new(:span, [" is an image."]),
	     ])
    ]
  ],
  ["http://www.youtube.com/v/PVY5IpSDUYE",
   [Node.new(:p, [
       Node.new(:object, [
		  Node.new(:param, [], 
			   {:name=>'movie', :value=>"http://www.youtube.com/v/PVY5IpSDUYE",}
			   ),
		  Node.new(:param, [],
			   {:name=>'wmode', :value=>'transparent',}
			   ),
		  Node.new(:embed, [],
			   { :type=>'application/x-shockwave-flash',
			     :wmode=>'transparent',
			     :src=>"http://www.youtube.com/v/PVY5IpSDUYE",
			     :width=>'425', :height=>'350',}
			   )
		],
		{:width=>'425', :height=>'350',})
	     ])
    ]
  ],
  ["http://www.youtube.com/watch?v=KKTDRqQtPO8",
   [Node.new(:p, [
       Node.new(:object, [
		  Node.new(:param, [], 
			   {:name=>'movie', :value=>"http://www.youtube.com/v/KKTDRqQtPO8",}
			   ),
		  Node.new(:param, [],
			   {:name=>'wmode', :value=>'transparent',}
			   ),
		  Node.new(:embed, [],
			   { :type=>'application/x-shockwave-flash',
			     :wmode=>'transparent',
			     :src=>"http://www.youtube.com/v/KKTDRqQtPO8",
			     :width=>'425', :height=>'350',}
			   )
		],
		{:width=>'425', :height=>'350',})
	     ])
    ]
   ],
  ["""Oh my \"Gosh,\" said 'Jonah' and 'Tom.' This \"Shure\" isn't my idea of Quotes.""", 
    [Node.new(:p, [
		Node.new(:span,
			 ["Oh my &#8220;Gosh,&#8221; said &#8216;Jonah&#8217; and &#8216;Tom.&#8217; This &#8220;Shure&#8221; isn&#8217;t my idea of Quotes."]
        )
	      ])
    ]
  ],
  ["Someone's ``being'' too `clever' with quotes.",
    [Node.new(:p, [
		Node.new(:span,
			 ["Someone&#8217;s &#8220;being&#8221; too &#8216;clever&#8217; with quotes."]
			 ),
	      ]),
    ]
  ],
  ["Whatever happened -- I wondered -- to Illimunated-Distributed Motherf----ers?",
    [Node.new(:p, [
      Node.new(:span,
         ["Whatever happened &#8212; I wondered &#8212; to Illimunated-Distributed Motherf&#8212;&#8212;ers?"]
	       )
	      ])
    ]
  ],
  ["what... I think... nevermind.",
    [Node.new(:p, [
		Node.new(:span,
			 ["what&#8230; I think&#8230; nevermind."]
			 )
	      ])
     ]
  ],
  ["*bold http://www.theory.org/ URL * and _italic http://www.theory.org/ URL_ and *http://www.theory.org extra stuff*",
    [Node.new(:p, [
		Node.new(:b, [
			   Node.new(:span, ["bold "]),
			   LinkNode.new('http://www.theory.org/'),
			   Node.new(:span, [" URL"]),
			 ]),
		Node.new(:span, [" and "]),
		Node.new(:i, [
			   Node.new(:span, ["italic "]),
			   LinkNode.new('http://www.theory.org/'),
			   Node.new(:span, [" URL"]),
			 ]),
		Node.new(:span, [" and "]),
		Node.new(:b, [
			   LinkNode.new('http://www.theory.org'),
			   Node.new(:span, [' extra stuff']),
			 ]),
	      ]),
    ]
  ],
  ["this is *bold _and italic *and I dunno* what_ this* is.",
    [Node.new(:p, [
		Node.new(:span, ["this is "]),
		Node.new(:b, [
			   Node.new(:span, ["bold ", "_", "and italic "])
			 ]),
		Node.new(:span, ["and I dunno"]),
		Node.new(:b, [
			   Node.new(:span, [" what", "_", " this"]),
			 ]),
		Node.new(:span, [" is."]),
	      ])
     ]
  ],
  ["but *I dunno _what* this_ is *supposed to* be.",
    [Node.new(:p, [
		Node.new(:span, ["but "]),
		Node.new(:b, [
			 Node.new(:span, ["I dunno ", "_", "what"])
			 ]),
		Node.new(:span, [" this", "_", " is "]),
		Node.new(:b, [
			   Node.new(:span, ["supposed to"])
			 ]),
		Node.new(:span, [" be."])
	      ])
     ]
  ],
  # Test attempted HTML insertion
  ['<a href="spleengrokes@email.com" target="_blank">Contact Me</a>',
    [Node.new(:p, [
		Node.new(:span, ["&lt;a "]),
		EmailNode.new("href=“spleengrokes@email.com"), ###
		Node.new(:span, ["&#8221; target=&#8220;", "_", "blank&#8221;", "&gt;", "Contact Me&lt;/a", "&gt;"])
	      ])
     ]
  ],
  # Test identification of URLs that begin with www.
  ['go to www.google.com but not ww.goggle.com nor goggoil.com nor gar.goyle.com',
    [Node.new(:p, [
		Node.new(:span, ["go to "]),
		LinkNode.new('http://www.google.com'),
		Node.new(:span, [' but not ww.goggle.com nor goggoil.com nor gar.goyle.com'])
	      ])
    ]
  ],
  ["""Hello this is a list:

 # item 1 is #1!
 # item 2 has some  stuff
 # item 3 is really long and it just goes on for a while, longer than fifty characters and more of item 3

And no more of the list.
   """,
    [Node.new(:p, [Node.new(:span, ["Hello this is a list: "])]),
      Node.new(:ol, [
		 Node.new(:li, [Node.new(:span, ["item 1 is #1! "])]),
		 Node.new(:li, [Node.new(:span, ["item 2 has some  stuff "])]),
		 Node.new(:li, [Node.new(:span, ["item 3 is really long and it just goes on for a while, longer than fifty characters and more of item 3 "])]),
	       ]),
      Node.new(:p, [Node.new(:span, ["And no more of the list. "])])],
  ],
  ["""Hello this is a list:

 1. item #1 is #1!
 2. item #2 has some  stuff
 77. item #77 is really long and it just goes on for a while, longer than fifty characters and more of item #77

And no more of the list.
   """,
    [Node.new(:p, [Node.new(:span, ["Hello this is a list: "])]),
     Node.new(:ol, [
		Node.new(:li, [Node.new(:span, ["item #1 is #1! "])]),
		Node.new(:li, [Node.new(:span, ["item #2 has some  stuff "])]),
		Node.new(:li, [Node.new(:span, ["item #77 is really long and it just goes on for a while, longer than fifty characters and more of item #77 "])]),
	      ]),
     Node.new(:p, [Node.new(:span, ["And no more of the list. "])])
    ],
  ],
  ["""Hello this is a list:

 * item is here
 * item has some  stuff
 * item is really long and it just goes on for a while, longer than fifty characters and more of item #77

And no more of the list.
   """,
    [Node.new(:p, [Node.new(:span, ["Hello this is a list: "])]),
     Node.new(:ul, [
      Node.new(:li, [Node.new(:span, ["item is here "])]),
      Node.new(:li, [Node.new(:span, ["item has some  stuff "])]),
      Node.new(:li, [Node.new(:span, ["item is really long and it just goes on for a while, longer than fifty characters and more of item #77 "])]),
	      ]),
      Node.new(:p, [Node.new(:span, ["And no more of the list. "])])
    ],
  ],
  ["""Hello this is a list:

 • item is here
 • item has some  stuff
 • item is really long and it just goes on for a while, longer than fifty characters and more of item #77

And no more of the list.
   """,
    [Node.new(:p, [Node.new(:span, ["Hello this is a list: "])]),
      Node.new(:ul, [
		 Node.new(:li, [Node.new(:span, ["item is here "])]),
		 Node.new(:li, [Node.new(:span, ["item has some  stuff "])]),
		 Node.new(:li, [Node.new(:span, ["item is really long and it just goes on for a while, longer than fifty characters and more of item #77 "])]),
	       ]),
      Node.new(:p, [Node.new(:span, ["And no more of the list. "])])
    ],
  ],
  ["""Hello this is a list:

 - item is here
 - item has some  stuff
 - item is really long and it just goes on for a while, longer than fifty characters and more of item #77

And no more of the list. """,
    [Node.new(:p, [Node.new(:span, ["Hello this is a list: "])]),
      Node.new(:ul, [
		 Node.new(:li, [Node.new(:span, ["item is here "])]),
		 Node.new(:li, [Node.new(:span, ["item has some  stuff "])]),
		 Node.new(:li, [Node.new(:span, ["item is really long and it just goes on for a while, longer than fifty characters and more of item #77 "])]),
      ]),
      Node.new(:p, [Node.new(:span, ["And no more of the list. "])])
    ],
  ],
  ["*this is bold*",
    [Node.new(:p, [Node.new(:b, [Node.new(:span, ["this is bold"])])])]
  ],
  ["*this is just a leading star",
    [Node.new(:p, [Node.new(:span, ["*", "this is just a leading star"])])]
  ],
  [%(* line 1
* >> quoted item 2
* satan

paragraph not quoted paragraphy
),
    [Node.new(:ul, [
		Node.new(:li, [Node.new(:span, ["line 1 "])]),
		Node.new(:li, [
			   Node.new(:blockquote, [
				      Node.new(:p, [
						 Node.new(:blockquote, [
							    Node.new(:p, [
								       Node.new(:span, ["quoted item 2 "])
								     ])
							  ])
					       ])
				    ])
			 ]),
		Node.new(:li, [Node.new(:span, ["satan "])])
	      ]),
      Node.new(:p, [Node.new(:span, ["paragraph not quoted paragraphy "])]),
    ]
  ],
  [%(* item
* > item quote
* > butta

paragraph damage
),
    [Node.new(:ul, [
		Node.new(:li, [Node.new(:span, ["item "])]),
		Node.new(:li, [
			   Node.new(:blockquote, [
				      Node.new(:p, [Node.new(:span, ["item quote "])])
				    ])
			 ]),
		Node.new(:li, [
			   Node.new(:blockquote, [
				      Node.new(:p, [Node.new(:span, ["butta "])])
				    ])
			 ]),
	      ]),
      Node.new(:p, [
		 Node.new(:span, ["paragraph damage "])
	       ])
    ]
  ],
  
  [%(
> * quoted item 2
> * quoted item 3
),
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:ul, [
				      Node.new(:li, [Node.new(:span, ["quoted item 2 "])]),
				      Node.new(:li, [Node.new(:span, ["quoted item 3 "])]),
				    ]),
			 ])
	      ])
    ]
  ],

  [%(
> Bubba

> * quoted item 2
> * quoted item 3

> Toady
),
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:p, [Node.new(:span, ["Bubba "])])
			 ]),
		Node.new(:blockquote, [
			   Node.new(:ul, [
				      Node.new(:li, [Node.new(:span, ["quoted item 2 "])]),
				      Node.new(:li, [Node.new(:span, ["quoted item 3 "])]),
				    ]),
			 ]),
		Node.new(:blockquote, [
			   Node.new(:p, [Node.new(:span, ["Toady "])])
			 ]),
	      ]),
     ]
  ],
  [%(
> Bubba
>
> * quoted item 2
> * quoted item 3
>
> Toady
),
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:p, [Node.new(:span, ["Bubba "])])
			 ]),
		Node.new(:blockquote, [
			   Node.new(:ul, [
				      Node.new(:li, [Node.new(:span, ["quoted item 2 "])]),
				      Node.new(:li, [Node.new(:span, ["quoted item 3 "])]),
				    ]),
			 ]),
		Node.new(:blockquote, [
			   Node.new(:p, [Node.new(:span, ["Toady "])])
			 ]),
	      ]),
     ]
  ],
  [%(
Bubba
* quoted item 2
* quoted item 3
Toady
),
    [Node.new(:p, [Node.new(:span, ["Bubba "])]),
     Node.new(:ul, [
		Node.new(:li, [Node.new(:span, ["quoted item 2 "])]),
		Node.new(:li, [
			   Node.new(:span, ["quoted item 3 "]),
			   Node.new(:br),
			   Node.new(:span, ["Toady "]),
			 ]),
	      ]),
     ]
  ],
  [%(
> Bubba
> * quoted item 2
> * quoted item 3
> Toady
),
    [Node.new(:p, [
		Node.new(:blockquote, [
			   Node.new(:p, [Node.new(:span, ["Bubba "])]),
			   Node.new(:ul, [
				      Node.new(:li, [Node.new(:span, ["quoted item 2 "])]),
				      Node.new(:li, [
						 Node.new(:span, ["quoted item 3 "]),
						 Node.new(:br),
						 Node.new(:span, ["Toady "]),
					       ]),
				    ]),
			 ]),
	      ]),
     ]
  ],

]


w = PottyMouth.new(url_check_domains=["www.mysite.com", "mysite.com"],
		   url_white_lists=[
		     /https?:\/\/mysite\.com\/allowed\/service/,
		     /https?:\/\/mysite\.com\/safe\/url/,
		   ],
		   allow_media=true)

failures = 0
i = 0

for source, output in contents
  blocks = w.parse(source)
  generated = blocks.to_str
  expected = Node.new('div', output).to_str
  if generated != expected
    failures += 1
    puts "##{i}", "Expected:", expected, "Generated:", generated
    puts '=' * 70
    #break
  end
  i += 1
end

if failures
  puts "#{contents.length} tests; #{failures} failures"
end
